﻿namespace ClassLibrary1
{
    using System;
    using Telerik.Reporting;
    using Reporting = Telerik.Reporting;
    using Processing = Telerik.Reporting.Processing;

    public partial class TestReport : Report
    {
        public TestReport()
        {
            this.InitializeComponent();
        }


        private void table_NeedDataSource(object sender, EventArgs eventArgs)
        {
            Processing.Table table = (Processing.Table)sender;

            table.DataSource = table.DataObject["Details"];
        }

        private void table1_NeedDataSource(object sender, EventArgs e)
        {
            Processing.Table tbl = (Processing.Table)sender;

            tbl.DataSource = new MasterItem[]
            {
                new MasterItem()
                {
                    ID = 1,
                    Name = "Master 1",
                    Details = new[]
                    {
                        new DetailItem()
                        {
                            ID = 1,
                            Name = "Detail 1"
                        },
                        new DetailItem()
                        {
                            ID = 2,
                            Name = "Detail 2"
                        },
                        new DetailItem()
                        {
                            ID = 3,
                            Name = "Detail 3"
                        }
                    }
                },
                new MasterItem()
                {
                    ID = 2,
                    Name = "Master 2",
                    Details = new[]
                    {
                        new DetailItem()
                        {
                            ID = 1,
                            Name = "Detail 4"
                        },
                        new DetailItem()
                        {
                            ID = 2,
                            Name = "Detail 5"
                        },
                        new DetailItem()
                        {
                            ID = 3,
                            Name = "Detail 6"
                        }
                    }
                },
                new MasterItem()
                {
                    ID = 3,
                    Name = "Master 3",
                    Details = new[]
                    {
                        new DetailItem()
                        {
                            ID = 7,
                            Name = "Detail 7"
                        },
                        new DetailItem()
                        {
                            ID = 8,
                            Name = "Detail 8"
                        },
                        new DetailItem()
                        {
                            ID = 9,
                            Name = "Detail 9"
                        }
                    }
                }
            };
        }
    }

    public class MasterItem
    {
        public int ID
        {
            get;
            set;
        }

        public string Name
        {
            get;
            set;
        }

        public DetailItem[] Details
        {
            get;
            set;
        }
    }

    public class DetailItem
    {
        public int ID
        {
            get;
            set;
        }

        public string Name
        {
            get;
            set;
        }
    }
}
